' This class is "generated" and will be overwritten.
' Your customizations should be made in EmployeesRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace AuditTrail.Business

''' <summary>
''' The generated superclass for the <see cref="EmployeesRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="EmployeesTable"></see> class.
''' </remarks>
''' <seealso cref="EmployeesTable"></seealso>
''' <seealso cref="EmployeesRecord"></seealso>

<Serializable()> Public Class BaseEmployeesRecord
	Inherits PrimaryKeyRecord
	Implements IUserIdentityRecord


	Public Shared Shadows ReadOnly TableUtils As EmployeesTable = EmployeesTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub

#Region "IUserRecord Members"

	' Get the user's unique identifier
	Public Function GetUserId() As String Implements IUserRecord.GetUserId
		Return CType(Me, IRecord).GetString(CType(Me.TableAccess, IUserTable).UserIdColumn)
	End Function

#End Region


#Region "IUserIdentityRecord Members"

	' Get the user's name
	Public Function GetUserName() As String Implements IUserIdentityRecord.GetUserName
		Return CType(Me, IRecord).getString(CType(Me.TableAccess, IUserIdentityTable).UserNameColumn)
	End Function

	' Get the user's password
	Public Function GetUserPassword() As String Implements IUserIdentityRecord.GetUserPassword
		Return CType(Me, IRecord).getString(CType(Me.TableAccess, IUserIdentityTable).UserPasswordColumn)
	End Function

	' Get the user's email address
	Public Function GetUserEmail() As String Implements IUserIdentityRecord.GetUserEmail
		Return CType(Me, IRecord).getString(CType(Me.TableAccess, IUserIdentityTable).UserEmailColumn)
	End Function

	' Get a list of roles to which the user belongs
	Public Function GetUserRoles() As String() Implements IUserIdentityRecord.GetUserRoles
		Dim roles() As String
		If (TypeOf (Me) Is IUserRoleRecord) Then
			roles = New String(0) {}
			roles(0) = CType(Me, IUserRoleRecord).GetUserRole()
		Else
			Dim roleTable As IUserRoleTable = CType(Me.TableAccess, IUserIdentityTable).GetUserRoleTable()
			If (IsNothing(roleTable)) Then
				Return Nothing
#If False Then
			'Note: Not compiled for performance
			ElseIf (CType(roleTable, Object).Equals(Me.TableAccess)) Then
				'This should never occur because it should be handled above instead
#End If
			Else
				Dim filter As ColumnValueFilter = BaseFilter.CreateUserIdFilter(roleTable, Me.GetUserId())
				Dim order As New OrderBy(False, False)
				Dim roleRecords As ArrayList = roleTable.GetRecordList(filter, order, BaseTable.MIN_PAGE_NUMBER, BaseTable.MAX_BATCH_SIZE)
				Dim roleRecord As IUserRoleRecord
				Dim roleList As New ArrayList(roleRecords.Count)
				For Each roleRecord In roleRecords
					roleList.Add(roleRecord.GetUserRole())
				Next
				roles = CType(roleList.ToArray(GetType(String)), String())
			End If
		End If
		Return roles
	End Function

#End Region




#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.EmployeeID field.
	''' </summary>
	Public Function GetEmployeeIDValue() As ColumnValue
		Return Me.GetValue(TableUtils.EmployeeIDColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.EmployeeID field.
	''' </summary>
	Public Function GetEmployeeIDFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.EmployeeIDColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.LastName field.
	''' </summary>
	Public Function GetLastNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.LastNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.LastName field.
	''' </summary>
	Public Function GetLastNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.LastNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.LastName field.
	''' </summary>
	Public Sub SetLastNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LastNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.LastName field.
	''' </summary>
	Public Sub SetLastNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LastNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.FirstName field.
	''' </summary>
	Public Function GetFirstNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.FirstNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.FirstName field.
	''' </summary>
	Public Function GetFirstNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.FirstNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.FirstName field.
	''' </summary>
	Public Sub SetFirstNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.FirstNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.FirstName field.
	''' </summary>
	Public Sub SetFirstNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.FirstNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Title field.
	''' </summary>
	Public Function GetTitleValue() As ColumnValue
		Return Me.GetValue(TableUtils.TitleColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Title field.
	''' </summary>
	Public Function GetTitleFieldValue() As String
		Return CType(Me.GetValue(TableUtils.TitleColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Title field.
	''' </summary>
	Public Sub SetTitleFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.TitleColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Title field.
	''' </summary>
	Public Sub SetTitleFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.TitleColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.TitleOfCourtesy field.
	''' </summary>
	Public Function GetTitleOfCourtesyValue() As ColumnValue
		Return Me.GetValue(TableUtils.TitleOfCourtesyColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.TitleOfCourtesy field.
	''' </summary>
	Public Function GetTitleOfCourtesyFieldValue() As String
		Return CType(Me.GetValue(TableUtils.TitleOfCourtesyColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.TitleOfCourtesy field.
	''' </summary>
	Public Sub SetTitleOfCourtesyFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.TitleOfCourtesyColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.TitleOfCourtesy field.
	''' </summary>
	Public Sub SetTitleOfCourtesyFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.TitleOfCourtesyColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.BirthDate field.
	''' </summary>
	Public Function GetBirthDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.BirthDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.BirthDate field.
	''' </summary>
	Public Function GetBirthDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.BirthDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.BirthDate field.
	''' </summary>
	Public Sub SetBirthDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.BirthDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.BirthDate field.
	''' </summary>
	Public Sub SetBirthDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.BirthDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.BirthDate field.
	''' </summary>
	Public Sub SetBirthDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.BirthDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.HireDate field.
	''' </summary>
	Public Function GetHireDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.HireDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.HireDate field.
	''' </summary>
	Public Function GetHireDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.HireDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.HireDate field.
	''' </summary>
	Public Sub SetHireDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.HireDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.HireDate field.
	''' </summary>
	Public Sub SetHireDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.HireDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.HireDate field.
	''' </summary>
	Public Sub SetHireDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.HireDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Address field.
	''' </summary>
	Public Function GetAddressValue() As ColumnValue
		Return Me.GetValue(TableUtils.AddressColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Address field.
	''' </summary>
	Public Function GetAddressFieldValue() As String
		Return CType(Me.GetValue(TableUtils.AddressColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Address field.
	''' </summary>
	Public Sub SetAddressFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.AddressColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Address field.
	''' </summary>
	Public Sub SetAddressFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AddressColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.City field.
	''' </summary>
	Public Function GetCityValue() As ColumnValue
		Return Me.GetValue(TableUtils.CityColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.City field.
	''' </summary>
	Public Function GetCityFieldValue() As String
		Return CType(Me.GetValue(TableUtils.CityColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.City field.
	''' </summary>
	Public Sub SetCityFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CityColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.City field.
	''' </summary>
	Public Sub SetCityFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CityColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Region field.
	''' </summary>
	Public Function GetRegionValue() As ColumnValue
		Return Me.GetValue(TableUtils.RegionColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Region field.
	''' </summary>
	Public Function GetRegionFieldValue() As String
		Return CType(Me.GetValue(TableUtils.RegionColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Region field.
	''' </summary>
	Public Sub SetRegionFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RegionColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Region field.
	''' </summary>
	Public Sub SetRegionFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RegionColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.PostalCode field.
	''' </summary>
	Public Function GetPostalCodeValue() As ColumnValue
		Return Me.GetValue(TableUtils.PostalCodeColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.PostalCode field.
	''' </summary>
	Public Function GetPostalCodeFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PostalCodeColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.PostalCode field.
	''' </summary>
	Public Sub SetPostalCodeFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PostalCodeColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.PostalCode field.
	''' </summary>
	Public Sub SetPostalCodeFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PostalCodeColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Country field.
	''' </summary>
	Public Function GetCountryValue() As ColumnValue
		Return Me.GetValue(TableUtils.CountryColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Country field.
	''' </summary>
	Public Function GetCountryFieldValue() As String
		Return CType(Me.GetValue(TableUtils.CountryColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Country field.
	''' </summary>
	Public Sub SetCountryFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CountryColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Country field.
	''' </summary>
	Public Sub SetCountryFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CountryColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.HomePhone field.
	''' </summary>
	Public Function GetHomePhoneValue() As ColumnValue
		Return Me.GetValue(TableUtils.HomePhoneColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.HomePhone field.
	''' </summary>
	Public Function GetHomePhoneFieldValue() As String
		Return CType(Me.GetValue(TableUtils.HomePhoneColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.HomePhone field.
	''' </summary>
	Public Sub SetHomePhoneFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.HomePhoneColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.HomePhone field.
	''' </summary>
	Public Sub SetHomePhoneFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.HomePhoneColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Extension field.
	''' </summary>
	Public Function GetExtensionValue() As ColumnValue
		Return Me.GetValue(TableUtils.ExtensionColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Extension field.
	''' </summary>
	Public Function GetExtensionFieldValue() As String
		Return CType(Me.GetValue(TableUtils.ExtensionColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Extension field.
	''' </summary>
	Public Sub SetExtensionFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ExtensionColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Extension field.
	''' </summary>
	Public Sub SetExtensionFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ExtensionColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Photo field.
	''' </summary>
	Public Function GetPhotoValue() As ColumnValue
		Return Me.GetValue(TableUtils.PhotoColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Photo field.
	''' </summary>
	Public Function GetPhotoFieldValue() As Byte()
		Return CType(Me.GetValue(TableUtils.PhotoColumn).ToBinary(), Byte())
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Photo field.
	''' </summary>
	Public Sub SetPhotoFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PhotoColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Photo field.
	''' </summary>
	Public Sub SetPhotoFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.PhotoColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Photo field.
	''' </summary>
	Public Sub SetPhotoFieldValue(ByVal val As Byte ())
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PhotoColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Notes field.
	''' </summary>
	Public Function GetNotesValue() As ColumnValue
		Return Me.GetValue(TableUtils.NotesColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.Notes field.
	''' </summary>
	Public Function GetNotesFieldValue() As String
		Return CType(Me.GetValue(TableUtils.NotesColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Notes field.
	''' </summary>
	Public Sub SetNotesFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.NotesColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.Notes field.
	''' </summary>
	Public Sub SetNotesFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.NotesColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Function GetReportsToValue() As ColumnValue
		Return Me.GetValue(TableUtils.ReportsToColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Function GetReportsToFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.ReportsToColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Sub SetReportsToFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ReportsToColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Sub SetReportsToFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.ReportsToColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Sub SetReportsToFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ReportsToColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Sub SetReportsToFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ReportsToColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Sub SetReportsToFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ReportsToColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.CreatedOn field.
	''' </summary>
	Public Function GetCreatedOnValue() As ColumnValue
		Return Me.GetValue(TableUtils.CreatedOnColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.CreatedOn field.
	''' </summary>
	Public Function GetCreatedOnFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.CreatedOnColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.CreatedOn field.
	''' </summary>
	Public Sub SetCreatedOnFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CreatedOnColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.CreatedOn field.
	''' </summary>
	Public Sub SetCreatedOnFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.CreatedOnColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.CreatedOn field.
	''' </summary>
	Public Sub SetCreatedOnFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CreatedOnColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.CreatedBy field.
	''' </summary>
	Public Function GetCreatedByValue() As ColumnValue
		Return Me.GetValue(TableUtils.CreatedByColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.CreatedBy field.
	''' </summary>
	Public Function GetCreatedByFieldValue() As String
		Return CType(Me.GetValue(TableUtils.CreatedByColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.CreatedBy field.
	''' </summary>
	Public Sub SetCreatedByFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.CreatedByColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.CreatedBy field.
	''' </summary>
	Public Sub SetCreatedByFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.CreatedByColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.LastUpdatedOn field.
	''' </summary>
	Public Function GetLastUpdatedOnValue() As ColumnValue
		Return Me.GetValue(TableUtils.LastUpdatedOnColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.LastUpdatedOn field.
	''' </summary>
	Public Function GetLastUpdatedOnFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.LastUpdatedOnColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.LastUpdatedOn field.
	''' </summary>
	Public Sub SetLastUpdatedOnFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LastUpdatedOnColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.LastUpdatedOn field.
	''' </summary>
	Public Sub SetLastUpdatedOnFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.LastUpdatedOnColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.LastUpdatedOn field.
	''' </summary>
	Public Sub SetLastUpdatedOnFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LastUpdatedOnColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.LastUpdatedBy field.
	''' </summary>
	Public Function GetLastUpdatedByValue() As ColumnValue
		Return Me.GetValue(TableUtils.LastUpdatedByColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Employees_.LastUpdatedBy field.
	''' </summary>
	Public Function GetLastUpdatedByFieldValue() As String
		Return CType(Me.GetValue(TableUtils.LastUpdatedByColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.LastUpdatedBy field.
	''' </summary>
	Public Sub SetLastUpdatedByFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.LastUpdatedByColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Employees_.LastUpdatedBy field.
	''' </summary>
	Public Sub SetLastUpdatedByFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.LastUpdatedByColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.EmployeeID field.
	''' </summary>
	Public Property EmployeeID() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.EmployeeIDColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.EmployeeIDColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EmployeeIDSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EmployeeIDColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EmployeeIDDefault() As String
        Get
            Return TableUtils.EmployeeIDColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.LastName field.
	''' </summary>
	Public Property LastName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.LastNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.LastNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LastNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LastNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LastNameDefault() As String
        Get
            Return TableUtils.LastNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.FirstName field.
	''' </summary>
	Public Property FirstName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.FirstNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.FirstNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property FirstNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.FirstNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property FirstNameDefault() As String
        Get
            Return TableUtils.FirstNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.Title field.
	''' </summary>
	Public Property Title() As String
		Get 
			Return CType(Me.GetValue(TableUtils.TitleColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.TitleColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property TitleSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.TitleColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property TitleDefault() As String
        Get
            Return TableUtils.TitleColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.TitleOfCourtesy field.
	''' </summary>
	Public Property TitleOfCourtesy() As String
		Get 
			Return CType(Me.GetValue(TableUtils.TitleOfCourtesyColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.TitleOfCourtesyColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property TitleOfCourtesySpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.TitleOfCourtesyColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property TitleOfCourtesyDefault() As String
        Get
            Return TableUtils.TitleOfCourtesyColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.BirthDate field.
	''' </summary>
	Public Property BirthDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.BirthDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.BirthDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property BirthDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.BirthDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property BirthDateDefault() As String
        Get
            Return TableUtils.BirthDateColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.HireDate field.
	''' </summary>
	Public Property HireDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.HireDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.HireDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property HireDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.HireDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property HireDateDefault() As String
        Get
            Return TableUtils.HireDateColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.Address field.
	''' </summary>
	Public Property Address() As String
		Get 
			Return CType(Me.GetValue(TableUtils.AddressColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.AddressColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property AddressSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.AddressColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property AddressDefault() As String
        Get
            Return TableUtils.AddressColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.City field.
	''' </summary>
	Public Property City() As String
		Get 
			Return CType(Me.GetValue(TableUtils.CityColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.CityColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CitySpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CityColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CityDefault() As String
        Get
            Return TableUtils.CityColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.Region field.
	''' </summary>
	Public Property Region() As String
		Get 
			Return CType(Me.GetValue(TableUtils.RegionColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.RegionColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RegionSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RegionColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RegionDefault() As String
        Get
            Return TableUtils.RegionColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.PostalCode field.
	''' </summary>
	Public Property PostalCode() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PostalCodeColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PostalCodeColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PostalCodeSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PostalCodeColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PostalCodeDefault() As String
        Get
            Return TableUtils.PostalCodeColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.Country field.
	''' </summary>
	Public Property Country() As String
		Get 
			Return CType(Me.GetValue(TableUtils.CountryColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.CountryColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CountrySpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CountryColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CountryDefault() As String
        Get
            Return TableUtils.CountryColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.HomePhone field.
	''' </summary>
	Public Property HomePhone() As String
		Get 
			Return CType(Me.GetValue(TableUtils.HomePhoneColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.HomePhoneColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property HomePhoneSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.HomePhoneColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property HomePhoneDefault() As String
        Get
            Return TableUtils.HomePhoneColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.Extension field.
	''' </summary>
	Public Property Extension() As String
		Get 
			Return CType(Me.GetValue(TableUtils.ExtensionColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.ExtensionColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ExtensionSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ExtensionColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ExtensionDefault() As String
        Get
            Return TableUtils.ExtensionColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.Photo field.
	''' </summary>
	Public Property Photo() As Byte()
		Get 
			Return CType(Me.GetValue(TableUtils.PhotoColumn).ToBinary(), Byte())
		End Get
		Set (ByVal val As Byte ()) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.PhotoColumn)
		End Set
	End Property



	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PhotoSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PhotoColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PhotoDefault() As String
        Get
            Return TableUtils.PhotoColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.Notes field.
	''' </summary>
	Public Property Notes() As String
		Get 
			Return CType(Me.GetValue(TableUtils.NotesColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.NotesColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property NotesSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.NotesColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property NotesDefault() As String
        Get
            Return TableUtils.NotesColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.ReportsTo field.
	''' </summary>
	Public Property ReportsTo() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.ReportsToColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.ReportsToColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ReportsToSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ReportsToColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ReportsToDefault() As String
        Get
            Return TableUtils.ReportsToColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.CreatedOn field.
	''' </summary>
	Public Property CreatedOn() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.CreatedOnColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.CreatedOnColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CreatedOnSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CreatedOnColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CreatedOnDefault() As String
        Get
            Return TableUtils.CreatedOnColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.CreatedBy field.
	''' </summary>
	Public Property CreatedBy() As String
		Get 
			Return CType(Me.GetValue(TableUtils.CreatedByColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.CreatedByColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property CreatedBySpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.CreatedByColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property CreatedByDefault() As String
        Get
            Return TableUtils.CreatedByColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.LastUpdatedOn field.
	''' </summary>
	Public Property LastUpdatedOn() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.LastUpdatedOnColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.LastUpdatedOnColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LastUpdatedOnSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LastUpdatedOnColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LastUpdatedOnDefault() As String
        Get
            Return TableUtils.LastUpdatedOnColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Employees_.LastUpdatedBy field.
	''' </summary>
	Public Property LastUpdatedBy() As String
		Get 
			Return CType(Me.GetValue(TableUtils.LastUpdatedByColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.LastUpdatedByColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property LastUpdatedBySpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.LastUpdatedByColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property LastUpdatedByDefault() As String
        Get
            Return TableUtils.LastUpdatedByColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
